//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%383EF9A9C220.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%383EF9A9C220.cm

//## begin module%383EF9A9C220.cp preserve=no
//## end module%383EF9A9C220.cp

//## Module: TclStream%383EF9A9C220; Package specification
//## Subsystem: XSUser::UserInterface%3804B6846530
//	/local/data/verisB/dorman/Xspec/src/userint
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUser/UserInterface/TclStream.h

#ifndef TCL_STREAM_H
#define TCL_STREAM_H 1

//## begin module%383EF9A9C220.additionalIncludes preserve=no
//## end module%383EF9A9C220.additionalIncludes

//## begin module%383EF9A9C220.includes preserve=yes
//## end module%383EF9A9C220.includes

// xstcl
#include "XSUser/UserInterface/xstcl.h"
// XSstream
#include <XSUtil/Utils/XSstream.h>
//## begin module%383EF9A9C220.declarations preserve=no
//## end module%383EF9A9C220.declarations

//## begin module%383EF9A9C220.additionalDeclarations preserve=yes
//## end module%383EF9A9C220.additionalDeclarations


//## begin TclScript%385523580338.preface preserve=yes
//## end TclScript%385523580338.preface

//## Class: TclScript%385523580338
//## Category: XSUser::UserInterface%382C268A43D0
//## Subsystem: XSUser::UserInterface%3804B6846530
//## Persistence: Transient
//## Cardinality/Multiplicity: n



typedef string TclScript;

//## begin TclScript%385523580338.postscript preserve=yes
namespace xstcl {
        
        static Tcl_ChannelType* xsLogPtr;       
        
}
//## end TclScript%385523580338.postscript

//## begin TkIO%389888DF2238.preface preserve=yes
//## end TkIO%389888DF2238.preface

//## Class: TkIO%389888DF2238
//## Category: XSUser::UserInterface%382C268A43D0
//## Subsystem: XSUser::UserInterface%3804B6846530
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class TkIO : public XSchannel  //## Inherits: <unnamed>%38988926AD80
{
  //## begin TkIO%389888DF2238.initialDeclarations preserve=yes
  //## end TkIO%389888DF2238.initialDeclarations

  public:
    //## Constructors (generated)
      TkIO(const TkIO &right);

    //## Constructors (specified)
      //## Operation: TkIO%38AC58862880
      TkIO (char* winName = 0);

    //## Destructor (generated)
      ~TkIO();


    //## Other Operations (specified)
      //## Operation: read%38A97DBCC150
      //	TkIO::read is to be called when information is to be
      //	read from a GUI window created by a tk script.
      //
      //	The read,write functions follow the Unix O/S convention
      //	for return codes: they return 0, -1 as the read, write
      //	was successful or unsuccessful.
      virtual std::streamsize read (char* s, std::streamsize n = 1);

      //## Operation: setPrompt%38D2B2BA3758
      void setPrompt (const std::string& ps);

      //## Operation: prompts%38E273034F20
      void prompts (const std::string& script, const std::vector<std::string>& prompts, const std::vector<std::string>& infos);

    // Additional Public Declarations
      //## begin TkIO%389888DF2238.public preserve=yes
      //## end TkIO%389888DF2238.public

  protected:
    // Additional Protected Declarations
      //## begin TkIO%389888DF2238.protected preserve=yes
      //## end TkIO%389888DF2238.protected

  private:

    //## Other Operations (specified)
      //## Operation: write%38A97DFC7FF0
      //	TkIO::write is to be called to write the contents of the
      //	TclOutputStream to a tk window.
      //
      //	The read,write functions follow the Unix O/S convention
      //	for return codes: they return n, -1 as the read, write
      //	was successful or unsuccessful.`, where n is the number
      //	of characters read/written
      virtual std::streamsize write (const char* s, std::streamsize n);

      //## Operation: internalSetLogger%3B966F04030B
      virtual void internalSetLogger (const std::string& name, bool isErr = false);

      //## Operation: internalCloseLog%3B968E700285
      void internalCloseLog ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: window%38AC5BED3FB0
      const char* window () const;
      void window (char* value);

      //## Attribute: prompt%38BFDC402100
      //	For TkIO, the "prompt" is actually a tk script that
      //	defines
      //	a dialogue box. Whatever the user types into the
      //	window must be returned as a variable, and written
      //	eventually to the stream buffer.
      const TclScript prompt () const;

      //## Attribute: logChannel%3ABB71600282
      const Tcl_Channel logChannel () const;
      void logChannel (Tcl_Channel value);

    // Additional Private Declarations
      //## begin TkIO%389888DF2238.private preserve=yes
      //## end TkIO%389888DF2238.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin TkIO::window%38AC5BED3FB0.attr preserve=no  private: char* {U} winName
      char* m_window;
      //## end TkIO::window%38AC5BED3FB0.attr

      //## begin TkIO::prompt%38BFDC402100.attr preserve=no  private: TclScript {U} 
      TclScript m_prompt;
      //## end TkIO::prompt%38BFDC402100.attr

      //## begin TkIO::logChannel%3ABB71600282.attr preserve=no  private: Tcl_Channel {U} 0
      Tcl_Channel m_logChannel;
      //## end TkIO::logChannel%3ABB71600282.attr

    // Additional Implementation Declarations
      //## begin TkIO%389888DF2238.implementation preserve=yes
      //## end TkIO%389888DF2238.implementation

};

//## begin TkIO%389888DF2238.postscript preserve=yes
//## end TkIO%389888DF2238.postscript

//## begin TclIO%3898891AB9A8.preface preserve=yes
//## end TclIO%3898891AB9A8.preface

//## Class: TclIO%3898891AB9A8
//## Category: XSUser::UserInterface%382C268A43D0
//## Subsystem: XSUser::UserInterface%3804B6846530
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class TclIO : public XSchannel  //## Inherits: <unnamed>%3898892D1AE8
{
  //## begin TclIO%3898891AB9A8.initialDeclarations preserve=yes
  //## end TclIO%3898891AB9A8.initialDeclarations

  public:
    //## Constructors (generated)
      TclIO(const TclIO &right);

    //## Constructors (specified)
      //## Operation: TclIO%38AC59128390
      TclIO (Tcl_Channel channel);

    //## Destructor (generated)
      ~TclIO();


    //## Other Operations (specified)
      //## Operation: read%38A97E5A1E78
      //	Must call Tcl_GetsObj, store input in a tcl object,
      //	and insert the contents of the object into a stream
      //	buffer.
      virtual std::streamsize read (char* s, std::streamsize n = 1);

      //## Operation: setPrompt%3F4D122502A3
      virtual void setPrompt (const string& ps);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: prompt%3F4E0A99018B
      virtual const string& prompt () const;

    // Additional Public Declarations
      //## begin TclIO%3898891AB9A8.public preserve=yes
      //## end TclIO%3898891AB9A8.public

  protected:
    // Additional Protected Declarations
      //## begin TclIO%3898891AB9A8.protected preserve=yes
      //## end TclIO%3898891AB9A8.protected

  private:
    //## Constructors (generated)
      TclIO();


    //## Other Operations (specified)
      //## Operation: write%38A97E9A3220
      virtual std::streamsize write (const char* s, std::streamsize n);

      //## Operation: internalSetLogger%3B966EE402AD
      virtual void internalSetLogger (const std::string& name, bool isErr = false);

      //## Operation: internalCloseLog%3B968E6601A1
      void internalCloseLog ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: ioChannel%38AC5C046228
      const Tcl_Channel ioChannel () const;
      void ioChannel (Tcl_Channel value);

      //## Attribute: logChannel%38AC5C229418
      const Tcl_Channel logChannel () const;
      void logChannel (Tcl_Channel value);

    // Additional Private Declarations
      //## begin TclIO%3898891AB9A8.private preserve=yes
      //## end TclIO%3898891AB9A8.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin TclIO::ioChannel%38AC5C046228.attr preserve=no  private: Tcl_Channel {U} channel
      Tcl_Channel m_ioChannel;
      //## end TclIO::ioChannel%38AC5C046228.attr

      //## begin TclIO::logChannel%38AC5C229418.attr preserve=no  private: Tcl_Channel {U} 0
      Tcl_Channel m_logChannel;
      //## end TclIO::logChannel%38AC5C229418.attr

      //## begin TclIO::prompt%3F4E0A99018B.attr preserve=no  public: string {U} 
      string m_prompt;
      //## end TclIO::prompt%3F4E0A99018B.attr

    // Additional Implementation Declarations
      //## begin TclIO%3898891AB9A8.implementation preserve=yes
      //## end TclIO%3898891AB9A8.implementation

};

//## begin TclIO%3898891AB9A8.postscript preserve=yes
//## end TclIO%3898891AB9A8.postscript

// Class TkIO 

//## Get and Set Operations for Class Attributes (inline)

inline const char* TkIO::window () const
{
  //## begin TkIO::window%38AC5BED3FB0.get preserve=no
  return m_window;
  //## end TkIO::window%38AC5BED3FB0.get
}

inline void TkIO::window (char* value)
{
  //## begin TkIO::window%38AC5BED3FB0.set preserve=no
  m_window = value;
  //## end TkIO::window%38AC5BED3FB0.set
}

inline const TclScript TkIO::prompt () const
{
  //## begin TkIO::prompt%38BFDC402100.get preserve=no
  return m_prompt;
  //## end TkIO::prompt%38BFDC402100.get
}

inline const Tcl_Channel TkIO::logChannel () const
{
  //## begin TkIO::logChannel%3ABB71600282.get preserve=no
  return m_logChannel;
  //## end TkIO::logChannel%3ABB71600282.get
}

inline void TkIO::logChannel (Tcl_Channel value)
{
  //## begin TkIO::logChannel%3ABB71600282.set preserve=no
  m_logChannel = value;
  //## end TkIO::logChannel%3ABB71600282.set
}

// Class TclIO 

//## Get and Set Operations for Class Attributes (inline)

inline const Tcl_Channel TclIO::ioChannel () const
{
  //## begin TclIO::ioChannel%38AC5C046228.get preserve=no
  return m_ioChannel;
  //## end TclIO::ioChannel%38AC5C046228.get
}

inline void TclIO::ioChannel (Tcl_Channel value)
{
  //## begin TclIO::ioChannel%38AC5C046228.set preserve=no
  m_ioChannel = value;
  //## end TclIO::ioChannel%38AC5C046228.set
}

inline const Tcl_Channel TclIO::logChannel () const
{
  //## begin TclIO::logChannel%38AC5C229418.get preserve=no
  return m_logChannel;
  //## end TclIO::logChannel%38AC5C229418.get
}

inline void TclIO::logChannel (Tcl_Channel value)
{
  //## begin TclIO::logChannel%38AC5C229418.set preserve=no
  m_logChannel = value;
  //## end TclIO::logChannel%38AC5C229418.set
}

inline const string& TclIO::prompt () const
{
  //## begin TclIO::prompt%3F4E0A99018B.get preserve=no
  return m_prompt;
  //## end TclIO::prompt%3F4E0A99018B.get
}

//## begin module%383EF9A9C220.epilog preserve=yes
//## end module%383EF9A9C220.epilog


#endif
